image: registry.gitlab.com/yakshaving.art/dockerfiles/go-builder:latest
stages:
  - build
  # - release

build-binary:
  stage: build
  coverage: '/^total:\s+\(statements\)\s+(\d+.\d+)%$/'
  variables:
    CGO_ENABLED: 0
    GOCACHE: ${CI_PROJECT_DIR}/.cache/go-build
  cache:
    key: build-cache
    paths:
      - .cache/go-build
  artifacts:
    paths:
      - pokemanager
  script:
    - make test build

.build-image: &build-image
  image: docker:stable
  stage: release
  services:
    - docker:dind
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_DRIVER: overlay2
  before_script:
    - echo ${CI_JOB_TOKEN} | docker login -u gitlab-ci-token --password-stdin ${CI_REGISTRY}
  after_script:
    - docker logout ${CI_REGISTRY}

# release_latest:
#   <<: *build-image
#   script:
#     - docker build --cache-from ${CI_REGISTRY_IMAGE}:latest
#       --tag ${CI_REGISTRY_IMAGE}:latest .
#     - docker push ${CI_REGISTRY_IMAGE}:latest
#   only:
#     - master

# release_tag:
#   <<: *build-image
#   script:
#     - docker build --cache-from ${CI_REGISTRY_IMAGE}:latest
#       --tag ${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG} .
#     - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}
#   only:
#     - tags
